
//+------------------------------------------------------------------
//| %r normalized
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers    1
#property indicator_color1     DodgerBlue
#property indicator_width1     2
#property indicator_levelcolor DarkSlateGray

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    WprPeriod       = 14;
extern int    WprPrice        = 4; 
extern int    levelOs         = -40;
extern int    levelOb         = 40;

extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = true;

//
//
//
//
//

double wpr[];
double price[];
double trend[];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
// 
//
//
//
//

int init()
{
    IndicatorBuffers(3);
    SetIndexBuffer(0,wpr);
    SetIndexBuffer(1,price);
    SetIndexBuffer(2,trend);
    SetLevelValue(0,0);
    SetLevelValue(1,levelOs);
    SetLevelValue(2,levelOb);
    
    //
    //
    //
    //
    //
   
      indicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame == "returnBars");     if (returnBars)     return(0);
      calculateValue    = (TimeFrame == "calculateValue"); if (calculateValue) return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);   

   //
   //
   //
   //
   //
    
   IndicatorShortName(timeFrameToString(timeFrame)+"  %R  (" +WprPeriod+ ")");
 return(0);
}

//
//
//
//
//

int deinit() { return(0); }

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { wpr[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
      for(int i=limit; i>=0; i--)
      {
             price[i] = iMA(NULL,0,1,0,MODE_SMA,WprPrice,i); 
             double hi   = High[Highest(NULL, 0, MODE_HIGH,WprPeriod,i)];
             double lo   = Low[Lowest(NULL,   0, MODE_LOW, WprPeriod,i)];
             if (hi!=lo)      
                  wpr[i] = 50+(-100)*(hi - price[i]) / (hi - lo);
             else wpr[i] = 0;  
                trend[i] = trend[i+1]; 
 
      if (wpr[i] > levelOs && wpr[i+1] <= levelOs) trend[i] =  1;
      if (wpr[i] < levelOb && wpr[i+1] >= levelOb) trend[i] = -1;
      
      }
      
      manageAlerts();
    return(0);
    }
    
    //
    //
    //
    //
    //       
    
    limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
    
    for(i=limit; i>=0; i--)
    {
    
      int y = iBarShift(NULL,timeFrame,Time[i]);
         wpr[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",WprPeriod,WprPrice,0,y);
         trend[i]= iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",WprPeriod,WprPrice,2,y);

   }
      
   manageAlerts();  
   return(0);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
// 
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"oversold");
         if (trend[whichBar] ==-1) doAlert(whichBar,"overbought");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(timeFrame)+" wpr is ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," wpr "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
// 
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}


